//	.mq4
//	 " "
// 

#property copyright "Ale"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 C'0,54,82'
#property indicator_color2 C'0,54,82'
#property indicator_color3 C'0,57,58'
#property indicator_color4 C'0,57,58'
#property indicator_width1 13
#property indicator_width2 13
#property indicator_width3 13
#property indicator_width4 13

extern string	` = "**   :";
extern string	glo.sFilterTop = "13-31"; //    
extern string	glo.sFilterBot = "69-88"; //    
extern int		glo.iBarsLimit = 1000; //     


string
	glo.sIndicatorName = ""
;
double
	glo.dPoint, //  
	glo.adBufTopLow[], glo.adBufTopHigh[], glo.adBufBotLow[], glo.adBufBotHigh[], //      
	glo.dFilterTopLow, glo.dFilterTopHigh, glo.dFilterBotLow, glo.dFilterBotHigh //       
;


int init() {
	SetIndexBuffer(0, glo.adBufTopLow); SetIndexStyle(0, DRAW_HISTOGRAM);
	SetIndexBuffer(1, glo.adBufTopHigh); SetIndexStyle(1, DRAW_HISTOGRAM);
	SetIndexBuffer(2, glo.adBufBotLow); SetIndexStyle(2, DRAW_HISTOGRAM);
	SetIndexBuffer(3, glo.adBufBotHigh); SetIndexStyle(3, DRAW_HISTOGRAM);
	
	IndicatorShortName(glo.sIndicatorName);
	
	glo.dPoint = Point; //  
	if(MarketInfo(Symbol(), MODE_DIGITS) == 5 || MarketInfo(Symbol(), MODE_DIGITS) == 3) glo.dPoint *= 10; //   
	string
		asString[2]
	;
	StringToArray(StringTrimLeft(StringTrimRight(glo.sFilterBot)), asString, "-");
	glo.dFilterBotLow = StrToDouble(asString[0]) * glo.dPoint;
	glo.dFilterBotHigh = StrToDouble(asString[1]) * glo.dPoint;
	StringToArray(StringTrimLeft(StringTrimRight(glo.sFilterTop)), asString, "-");
	glo.dFilterTopLow = StrToDouble(asString[0]) * glo.dPoint;
	glo.dFilterTopHigh = StrToDouble(asString[1]) * glo.dPoint;
	
	return (0);
}


int deinit() {
	return(0);
}


int start() {
	int
		iPoints,
		iCounted = IndicatorCounted(),
		iBar,
		iToCount
	;
	double
		dPrice,
		dLowSpot
	;
	
	if(iCounted < 0) return(-1);
	if(iCounted > 0) iCounted--;
	iToCount = MathMin(glo.iBarsLimit, Bars - iCounted);
	
	for(iBar = iToCount; iBar >= 0; iBar--) {
		dPrice = Close[iBar]; //  
		iPoints = dPrice / glo.dPoint; //   
		dLowSpot = (iPoints - iPoints % 100) * glo.dPoint; //     
//SaveLog(iBar + ": dPrice=" + dPrice + " iPoints=" + iPoints + " dLowSpot=" + dLowSpot);
		if(dPrice <= dLowSpot + glo.dFilterTopHigh) { //       
			glo.adBufBotLow[iBar] = dLowSpot - 100 * glo.dPoint + glo.dFilterBotLow;
			glo.adBufBotHigh[iBar] = dLowSpot - 100 * glo.dPoint + glo.dFilterBotHigh;
			glo.adBufTopLow[iBar] = dLowSpot + glo.dFilterTopLow;
			glo.adBufTopHigh[iBar] = dLowSpot + glo.dFilterTopHigh;
		}
		else if(dPrice <= dLowSpot + glo.dFilterBotHigh) { //          
			glo.adBufBotLow[iBar] = dLowSpot + glo.dFilterBotLow;
			glo.adBufBotHigh[iBar] = dLowSpot + glo.dFilterBotHigh;
			glo.adBufTopLow[iBar] = dLowSpot + glo.dFilterTopLow;
			glo.adBufTopHigh[iBar] = dLowSpot + glo.dFilterTopHigh;
		}
		else { //         
			glo.adBufBotLow[iBar] = dLowSpot + glo.dFilterBotLow;
			glo.adBufBotHigh[iBar] = dLowSpot + glo.dFilterBotHigh;
			glo.adBufTopLow[iBar] = dLowSpot + 100 * glo.dPoint + glo.dFilterTopLow;
			glo.adBufTopHigh[iBar] = dLowSpot + 100 * glo.dPoint + glo.dFilterTopHigh;
		}
	}
	
	return (0);
}

void StringToArray (string sInput, string& asOutput[], string sDelim) {
	ArrayResize(asOutput, 0);
	int iStartPos = 0;
	while(iStartPos < StringLen(sInput)) {
		int iDelPos = StringFind(sInput, sDelim, iStartPos);
		if(iDelPos < 0) {
			string sNextElem = StringSubstr(sInput, iStartPos);
			iStartPos = StringLen(sInput);
		}
		else {
			sNextElem = StringSubstr(sInput, iStartPos, iDelPos - iStartPos);
			iStartPos = iDelPos + 1;
		}
		ArrayResize(asOutput, ArraySize(asOutput) + 1);
		asOutput[ArraySize(asOutput)-1] = sNextElem;
	}
}

